[tox]
minversion = 1.6
envlist = py27,flake8
skipsdist = True

[tox:jenkins]
downloadcache = ~/cache/pip

[testenv]
usedevelop = True
install_command = pip install {opts} {packages}
deps = -r{toxinidir}/requirements.txt
       -r{toxinidir}/test-requirements.txt
setenv =
  PYTHONDONTWRITEBYTECODE=1
whitelist_externals = sh
commands =
  py.test

[testenv:docs]
commands = python setup.py build_sphinx -E

[testenv:cover]
commands = py.test --cov=gatekeeper

[testenv:flake8]
commands = sh tools/pretty_flake8.sh

[testenv:pep8]
basepython = python2.7
commands = sh tools/pretty_flake8.sh

[testenv:pyflakes]
commands = sh tools/pretty_flake8.sh

[testenv:pip-check-reqs]
# do not install test-requirements as that will pollute the virtualenv for
# determining missing packages
# this also means that pip-missing-reqs must be installed separately, outside
# of the requirements.txt files
deps = pip-check-reqs
       -r{toxinidir}/requirements.txt
commands=pip-missing-reqs -d --ignore-file=gatekeeper/tests/* gatekeeper

[testenv:functional]
usedevelop = False
setenv = VIRTUAL_ENV={envdir}
         OS_TEST_PATH=functionaltests/
passenv = TEMPEST_CONFIG
          OS_STDOUT_CAPTURE
          OS_STDERR_CAPTURE
          OS_LOG_CAPTURE
          OS_DEBUG

[testenv:venv]
commands = {posargs}

[flake8]
# ignored flake8 codes:
# H302 import only modules
# H306 imports not in alphabetical order
# H402 one line docstring needs punctuation
# H404 multi line docstring should start with a summary
# H405 multi line docstring summary not separated with an empty line
# H904 Wrap long lines in parentheses instead of a backslash
# E126 continuation line over-indented for hanging indent
# E128 continuation line under-indented for visual indent

ignore = H302,H306,H402,H404,H405,H904,E126,E128
exclude = .venv,.git,.tox,dist,doc,*openstack/common*,*openstack/deprecated*,*lib/python*,*egg,build,tools
